/***************************************************************************                                              
 *   Copyright (C) 2011 Joven Club de Computacion y Electronica V.C        *                                      
 *   Written by Darien Alonso Camacho <darienad030111@vcl.jovenclub.cu>    *                                         
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.           *
 **************************************************************************/

#ifndef TIMELINE_H
#define TIMELINE_H

#include <mingpp.h>
#include <vector>
#include "timelinelayer.h"
using namespace std;

class TiXmlElement;

class Timeline
{
public:
    Timeline( SWFMovie* movie );
    void addLayer();
    //void addFrameToLayer( int layer_pos );
    void completeFrames( int layer_pos, int frame_pos, int duration );
    void addElement( int layer_pos , int frame_pos, TiXmlElement* element );
    void removeItemsToBeRemoved();
    void setFrameDuration( int layer_pos , int frame_pos, int duration );


    void dumpMovie();

private:
    vector<TimelineLayer*> layers;

    SWFMovie* movie;
};

#endif // TIMELINE_H
