/***************************************************************************                                              
 *   Copyright (C) 2011 Joven Club de Computacion y Electronica V.C        *                                      
 *   Written by Darien Alonso Camacho <darienad030111@vcl.jovenclub.cu>    *                                         
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.           *
 **************************************************************************/

#include "timelinelayer.h"

TimelineLayer::TimelineLayer( SWFMovie* movie )
{
    this->movie = movie;
}

/*void TimelineLayer::addFrame()
{
    Frame* f = new Frame( this, this->movie );
    frames.push_back( f );
}*/

void TimelineLayer::completeFrames( int frame_pos, int duration )
{
//When first frame is not a key frame
    if( frames.empty() && frame_pos > 0 )
    {
        //Append a frame_pos number of frames
        for( int i = 0; i <= frame_pos + 1; i ++ )
        {
            Frame* f = new Frame( this, this->movie );
            frames.push_back( f );
        }
    }

    int frames_count = frame_pos + duration;
    int more_frames = frames_count - frame_pos;
    if( frames.size() <= frames_count )
    {
        //Append a more_frames number of frames
        for( int i = 0; i <= more_frames + 1; i ++ )
        {
            Frame* f = new Frame( this, this->movie );
            frames.push_back( f );
        }
    }

}

void TimelineLayer::addElement( int frame_pos, TiXmlElement* element )
{
    if( frame_pos >= 0 && frame_pos < frames.size() )
    {
        Frame* frame = frames.at( frame_pos );
        if( frame )
        {
            //Add item
            frame->addElement( element );
        }
    }
    else
    {
        cout<< "cz2swf debug: In TimelineLayer::addElement(...), frame_pos="<< frame_pos <<" fuera de rango." <<endl;
    }
}

void TimelineLayer::addItemToBeRemoved( int frame_pos, SWFDisplayItem* item )
{
    if( frame_pos >= 0 && frame_pos < frames.size() )
    {cout<< "Eliminar en el frame "<< frame_pos <<endl;
        Frame* frame = frames.at( frame_pos );
        if( frame )
        {
            //Add item to be removed
            frame->addItemToBeRemoved( item );
        }
    }
    else
    {
        cout<< "cz2swf debug: In TimelineLayer::addItemToBeRemoved(...), frame_pos="<< frame_pos <<" fuera de rango." <<endl;
    }
}

void TimelineLayer::removeItemsToBeRemoved()
{
    for( int i = 0; i < frames.size(); i++ )
    {
        Frame* frame = frames.at( i );
        if( frame )
        {
            frame->removeItemsToBeRemoved();
        }
    }
}

void TimelineLayer::setFrameDuration( int frame_pos, int duration )
{
    if( frame_pos >= 0 && frame_pos < frames.size() )
    {
        Frame* frame = frames.at( frame_pos );
        if( frame )
        {
            //
            frame->setDuration( duration );
        }
    }
    else
    {
        cout<< "cz2swf debug: In TimelineLayer::setFrameDuration(...), frame_pos="<< frame_pos <<" fuera de rango." <<endl;
    }
}

int TimelineLayer::getFramesCount()
{
    return frames.size();
}

Frame* TimelineLayer::getFrame( int frame_pos )
{
    Frame* result = 0;

    if( frame_pos >= 0 && frame_pos < frames.size() )
    {
        result = frames.at( frame_pos );
    }

    return result;
}

/*void TimelineLayer::draw()
{

}*/
