/***************************************************************************                                              
 *   Copyright (C) 2011 Joven Club de Computacion y Electronica V.C        *                                      
 *   Written by Darien Alonso Camacho <darienad030111@vcl.jovenclub.cu>    *                                         
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.           *
 **************************************************************************/

#ifndef TIMELINELAYER_H
#define TIMELINELAYER_H

#include <vector>
#include <iostream>
#include "frame.h"
using namespace std;

class TimelineLayer
{
public:
    TimelineLayer( SWFMovie* movie );
    //void addFrame();
    void addElement( int frame_pos, TiXmlElement* element );
    void addItemToBeRemoved( int frame_pos, SWFDisplayItem* item );
    void removeItemsToBeRemoved();
    void completeFrames( int frame_pos, int duration );
    void setFrameDuration( int frame_pos, int duration );
    int getFramesCount();
    Frame* getFrame( int frame_pos );
    //void draw();

private:
    vector<Frame*> frames;

    SWFMovie* movie;

};

#endif // TIMELINELAYER_H
